#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "itext.h"
#include "itext_file.h"

#include "itext_f2.h"

#include "xjp.h"
#include "xtext.h"

#include <sys/stat.h>

#define READ_ON 	0

#ifdef READ_ON
#include <sys/time.h>
#endif

#define ITEXT_TAB	4


static int RUBYON = 1;
static int SMLL = 0;


ICONTENT_T * content_link_alloc()
{
        ICONTENT_T *ic;

        if((ic = (ICONTENT_T *)malloc(sizeof(ICONTENT_T))) == NULL){
                fprintf(stderr,"False _content_link_alloc()(malloc)\n"); 
				return NULL; 
		}

        ic->filename = NULL; 
		ic->titlename = NULL; 
		ic->total_line = 0;
        ic->o_head = NULL; 
		ic->b_head = NULL; 
		ic->b_tail = NULL;

        return ic;
}
void content_link_free(ICONTENT_T *ic)
{       
        if(ic != NULL) ibuf_data_free(ic);
}               
static IBUF_T *ibuf_data_alloc()
{
	IBUF_T *it;

	if((it = (IBUF_T *)malloc(sizeof(IBUF_T))) == NULL){
		fprintf(stderr,"Error:  ibuf_add()(malloc())\n"); 
		return NULL; 
	}

	it->line = 0; 
	it->str = NULL;
	it->i_head = NULL; 
	it->i_tail = NULL;

	return it;
}
static void ibuf_data_add(IBUF_T **start,IBUF_T **end,IBUF_T *mg)
{
	if(*end){
			mg->next = NULL; mg->prev = *end;
			(*end)->next = mg; *end = mg;
	}else{
			mg->next = NULL; mg->prev = NULL;
			*end = mg; *start = mg;
	}

	return;
}
void ibuf_data_free(ICONTENT_T *book)
{
	IBUF_T *ib,*ibb;

	if(book->b_head == NULL) return;
	if(book->o_head != NULL) other_data_free(book->o_head);

	for(ib = book->b_head; ib != NULL; ib = ibb){

		ibb = ib->next; 

		if( ib->str ) free(ib->str);
		itext_data_free(ib->i_head); 

		free(ib); 

	}

	book->b_head = NULL; 
	book->b_tail = NULL; 
	book->o_head = NULL;
	book->total_line = 0;

	return;
}
static ITEXTR_T * itext_rubidata_alloc()
{
	ITEXTR_T *ir;

	if((ir = (ITEXTR_T *)malloc(sizeof(ITEXTR_T))) == NULL) 
		return NULL; 

	ir->c1 = 0;
	ir->c2 = 0;
	ir->kun = NULL;
	ir->next = NULL;
	ir->prev = NULL;

	return ir;
}
static void itext_rubidata_add(ITEXTR_T **start,ITEXTR_T **end,ITEXTR_T *mg)
{
	if( *end ){

		mg->next = NULL; mg->prev = *end;
		(*end)->next = (ITEXTR_T *)mg; *end = mg;

	}else{

		mg->next = NULL; mg->prev  = NULL;
		*end = mg; *start = mg;

	}

	return;
}
void itext_rubidata_free(ITEXTR_T *ihead)
{
	ITEXTR_T *ir,*irr;

	for(ir=ihead;ir!=NULL;ir=irr){

		irr = ir->next; 
		free(ir); 

	}

	return;
}
static ITEXT_T * itext_data_alloc()
{
	ITEXT_T *it;

	if((it = (ITEXT_T *)malloc(sizeof(ITEXT_T))) == NULL) 
		return NULL;

	it->c1 = ' '; it->c2 = ' ';
	it->off = 0; it->flag = 0;
	it->chu_string = NULL; it->pict_path = NULL;
	it->rubi_head = NULL; it->rubi_tail = NULL;
	it->chu_head = NULL; it->chu_tail = NULL;
	it->kun_head = NULL; it->kun_tail = NULL;

	return it;
}
static void itext_data_add(ITEXT_T **start,ITEXT_T **end,ITEXT_T *mg)
{
	if( *end ){

		mg->next = NULL; mg->prev = *end;
		(*end)->next = (ITEXT_T *)mg; *end = mg;

	}else{

		mg->next = NULL; mg->prev  = NULL;
		*end = mg; *start = mg;

	}

	return;
}
void itext_data_free(ITEXT_T *ihead)
{
	ITEXT_T *it,*itt;

	if(ihead == NULL) return;

	for(it=ihead;it!=NULL;it=itt){

		itt = it->next;

		if(it->chu_string != NULL) free(it->chu_string);
		if(it->pict_path != NULL ) free(it->pict_path);
		if(it->rubi_head != NULL) itext_rubidata_free(it->rubi_head);
		if(it->chu_head != NULL) itext_rubidata_free(it->chu_head);
		if(it->kun_head != NULL) itext_rubidata_free(it->kun_head);

		free(it);
	}

	return ;
}
void itext_data_pop(ITEXT_T **ihead,ITEXT_T **itail,ITEXT_T *it)
{

	if(it == NULL) return;

	if( it->prev == NULL && it->next == NULL ){
		*ihead = NULL;
		*itail = NULL;

		if(it->chu_string != NULL) free(it->chu_string);
		if(it->pict_path != NULL) free(it->pict_path);
		if(it->rubi_head != NULL) itext_rubidata_free(it->rubi_head);
		if(it->chu_head != NULL) itext_rubidata_free(it->chu_head);
		if(it->kun_head != NULL) itext_rubidata_free(it->kun_head);

		free(it);

		return;
	}

	if( it->prev == NULL ){

		it->next->prev = NULL;
		*ihead = it->next;

	}else if( it->next == NULL ){

		it->prev->next = NULL;
		*itail = it->prev;

	}else{

		it->prev->next = it->next;
		it->next->prev = it->prev;
	}

	if(it->chu_string != NULL) free(it->chu_string);
	if(it->pict_path != NULL) free(it->pict_path);
	if(it->rubi_head != NULL) itext_rubidata_free(it->rubi_head);
	if(it->kun_head != NULL) itext_rubidata_free(it->kun_head);

	free(it);

	return;
}
int ibuf_add(		IBUF_T **head,
			IBUF_T **tail,
			ITEXT_T *ihead,
			ITEXT_T *itail,
			char *str,
			int line		)
{
	IBUF_T *ib;

	if((ib = (IBUF_T *)ibuf_data_alloc()) == NULL) return -1;

	ib->line = line;
	ib->i_head = ihead; 
	ib->i_tail = itail;

	if( str != NULL ){
		int len;
		len = strlen(str);

		if( (ib->str = (char *)malloc(len + 2)) != NULL){
			memset(ib->str,0,len + 2);
			strncpy(ib->str,str,len);
		}
	}

	ibuf_data_add(head,tail,ib);

	return 0;
}
static int _check_cr(char *s)
{
	int i,m;
	char *p;

	i = 0;
	m = -1;
	p = s;

	for( p = s, i = 0; *p; p++, i++){

		if( (*p == '\r') || ( *p == '\n' && m < 0 ) ) 
			m = i;

		if( m >= 0 ) *p = 0;
	};

	return m;
}
int itextRubiDataInsert(ITEXTR_T **ihead,ITEXTR_T **itail,unsigned char c1,unsigned char c2 )
{
	ITEXTR_T *ir;


	if((ir = (ITEXTR_T *)itext_rubidata_alloc()) == NULL) return -1;

	ir->c1 = c1; 
	ir->c2 = c2; 

	itext_rubidata_add(ihead,itail,ir);

	return 0;
}
int itextDataInsert(	ITEXT_T **ihead,
			ITEXT_T **itail,
			unsigned char c1,
			unsigned char c2,
			int ej,
			int ch,
			int sm			)
{
	ITEXT_T *it;

	if((it = (ITEXT_T *)itext_data_alloc()) == NULL) return -1;

	it->c1 = c1; 
	it->c2 = c2;

	if( ej ) 
			OnFlag(it->flag,_EJC); 
	else 
			OfFlag(it->flag,_EJC);

	if( ch ) 
			OnFlag(it->flag,_CHU); 
	else 
			OfFlag(it->flag,_CHU);

	if( sm ){ 
			OnFlag(it->flag,_SML); 
			SetFlag1(it->flag,sm);

	}else{  
			OfFlag(it->flag,_SML);
	}


	itext_data_add(ihead,itail,it);

	return 0;
}
static unsigned char *  _check_ruby(unsigned char *p,ITEXT_T **ihead,ITEXT_T **itail)
{
	ITEXT_T *it,*it1;
	unsigned char c1,c2;
	int rub,i;

	if( RUBYON == 0 ) return p;

	c1 = *p;
	c2 = *(p + 1);
	if( c1 == AMARK && c2 == SRUBY ){ 

		p = p + 2;

		rub = 0;
		for( it = (*itail)->prev,i = 1; it != NULL; it = it1,i++ ){
			it1 = it->prev;

			if( it->c1 == AMARK && it->c2 == LRUBU ){
				rub = 1;
				itext_data_pop(ihead,itail,it);

			       	break;
			}
			if( !(it->c1 >= 0xb0) ) break;
		}
		if( rub ){
			OnFlag((*itail)->flag,_RUB); 
			SetFlag((*itail)->flag,i); 
		}

		while(1){
			c1 = *(p++);
			c2 = *(p++);

			if( c1 == AMARK && c2 == ERUBY ) break;

			itextRubiDataInsert(&(*itail)->rubi_head,&(*itail)->rubi_tail,c1,c2);

		}
	}

	return p;

}
static int _is_ruby(unsigned char *p)
{
	unsigned char c1,c2;

	if( *p == 0 || *(p + 1) == 0) return 0;

	c1 = *p;
	c2 = *(p + 1);

	if( c1 == AMARK && c2 == SRUBY ) return 1;

	return 0;
}
static int _is_chuki(unsigned char *p)
{
	unsigned char c1,c2,c3,c4;

	if( *p == 0 ) return 0;
	c1 = *p;

	if( *(p + 1) == 0 ) 
		return 0;
	else
		c2 = *(p + 1);

	if( *(p + 2) == 0 )
		return 0;
	else
		c3 = *(p + 2);

	if( *(p + 3) == 0 )
		return 0;
	else
		c4 = *(p + 3);


	if( 	(c1 == AMARK && c2 == SCHUS)  && 
		(c3 == AMARK && ( c4 == SHARP || c4 == ASTAR)) ){

		return 1;
	}else{
		return 0;
	}
}
static unsigned char * _check_tag(unsigned char *p,ITEXT_T **ihead,ITEXT_T **itail)
{
	ITEXTR_T *chu;
	char tp[3];

	unsigned char c1,c2;
	int ch = 0;

	if( RUBYON == 0 ) return p;

	p = _check_ruby(p,ihead,itail);

	if( (ch += _is_chuki(p)) > 0 ){	 

		if( *itail == NULL )
			itextDataInsert(ihead,itail,CHU_KEY_C1,CHU_KEY_C2,1,1,SMLL);

		p = p + 2;

		while(1){

			ch += _is_chuki(p);

			if( itextCheckEuc(p) ){

				c1 = *p;
				c2 = *(p + 1);

				if(c1 == AMARK && c2 == SCHUE){
					if( --ch == 0 ) break;
				}

				itextRubiDataInsert(&(*itail)->chu_head,&(*itail)->chu_tail,c1,c2);
				p = p + 2;

			}else{

				c1 = *p; 
				c2 = 0;
				itextRubiDataInsert(&(*itail)->chu_head,&(*itail)->chu_tail,c1,c2);
				p = p + 1;
			}
		}

		if( (*itail)->kun_head != NULL ){
			itext_rubidata_free((*itail)->kun_head);
			(*itail)->kun_head = NULL;
			(*itail)->kun_tail = NULL;
		}

		p = p + 2;
		p = checkRubyString(ihead,itail,&SMLL,p);
		
	}

	if( _is_chuki(p) ){
		p = _check_tag(p,ihead,itail);
	}

	if( _is_ruby(p) ){
		p = _check_tag(p,ihead,itail);
	}

	return p;
}
static char * _get_titlename(char *buf,int len)
{
	char *p;

	if( buf == NULL || len <= 0 ) return NULL;

	if((p = (char *)malloc(len + 2)) == NULL){
	       fprintf(stderr,"Error: _get_booktitle()(malloc())\n"); 
		   return 0; 
	}

	memset(p,0,len + 2);
	strncpy(p,buf,len); 

	return p;
}
static BLINE_T * _check_Header(iconv_t icon,ICONTENT_T *book,BLINE_T *bhead,int max,int *line)
{
	BLINE_T *bl;
	ITEXT_T *ihead, *itail; 
	char *buf;
	int f;

	if( (buf = (char *)malloc(max + EUC_BUFFER)) == NULL){
		fprintf(stderr,"Error: _check_Header malloc() main.c\n");
		return bhead;
	}

	f = 0;
	book->titlename = NULL;
	for( bl = bhead; bl != NULL; bl = bl->n ){

		memset(buf,0,max + EUC_BUFFER);
		if( itextConvKanjiCode(icon,buf,bl->p,bl->l) < 0 ) continue;

		if( _check_cr(buf) == 0) continue;

		if( Head_Line(buf) ){
		       	if( ++f == 2 ) break;
		}
		if( f == 0 ){

			if( book->titlename == NULL ){
				book->titlename = _get_titlename(buf,strlen(buf));
			}

			ihead = NULL; itail = NULL;
			itext_add(buf,&ihead,&itail);
			ibuf_add(&(book->b_head),&(book->b_tail),ihead,itail,buf,*line++); 

		}

	}
	free(buf);

	return bl;
}
static int _check_buffer(ICONTENT_T *book, char *buf_euc,int len,int *total_line)
{

	if(_check_cr(buf_euc) == 0){

		ibuf_add(&(book->b_head),&(book->b_tail),NULL,NULL,buf_euc,*total_line); 
		*total_line += 1;

		return 0;
	}
	/*
	if( BUF_FLAG == 2 ){

		fprintf(stderr,"_check_buffer BUF_FLAG(%d)\n",BUF_FLAG);
		checkRubyString(&((book->b_tail)->i_head),&((book->b_tail)->i_tail),&SMLL,NULL);

	        BUF_FLAG = 0;

	}
	*/

	return 1;
}
unsigned char * itext_next(unsigned char *np,ITEXT_T **ihead,ITEXT_T **itail)
{
	unsigned char c1,c2;
	unsigned char *p;

	p = _check_tag(np,ihead,itail);

	if( itextCheckEuc(p) ){

		c1 = *p++; 
		c2 = *p++;
		itextDataInsert(ihead,itail,c1,c2,1,0,SMLL);

	}else{
		if(*p == '\t'){
			int xj;

			for( xj = 0; xj < ITEXT_TAB; xj++ ){
				c1 = 0x20; c2 = 0;
				itextDataInsert(ihead,itail,c1,c2,0,0,SMLL);
			}
			p++;

		}else{

			c1 = *p++; c2 = 0;
			itextDataInsert(ihead,itail,c1,c2,0,0,SMLL);

		}
	}

	return p;
}
int itext_add( char *buf_euc, ITEXT_T **ihead, ITEXT_T **itail )
{
	unsigned char *p;

	p = (unsigned char *)buf_euc;

	while( *p ){

		p = itext_next(p,ihead,itail);
	}

	return 0;
}
int _test_01_1(FILE *fp,iconv_t icon,ICONTENT_T *book,int buf_size,int file_size)
{
	size_t fsize,ssize;

	char fbuf[BUFSIZ];
	char *sbuf = NULL;
	char *ebuf = NULL;

	BLINE_T *bhead,*bl;
	int line_max = 0;

	ITEXT_T *ihead = NULL; 
	ITEXT_T *itail = NULL;

	int total_size = 0; 
	int total_line = 0;

	int len = 0; 

	SMLL = 0;


	if( (sbuf = (char *)malloc(file_size + 2)) == NULL){
			fprintf(stderr,"Error: _test_01(sbuf_malloc)\n");
			return -1;
	}
	memset(sbuf,0,file_size + 2);

	ssize = fsize = 0;
	while( (fsize = fread(fbuf,sizeof(char),BUFSIZ,fp)) > 0){
			fbuf[fsize] = '\0';

			strncat(sbuf,fbuf,fsize);

			if( (ssize += fsize) > file_size){
					fprintf(stderr,"Error : _test_01(ssize+fsize)\n");
					return -1;
			}
	}

	if( (bhead = itextBufferLine(sbuf,&line_max)) == NULL ){
		fprintf(stderr,"Error: BufferLine main.c\n");
	       	return -1;
	}
	if( (bhead = _check_Header(icon,book,bhead,line_max,&total_line)) == NULL){
		fprintf(stderr,"Error: NULL main.c\n");
		return -1;
	}


	if( (ebuf = (char *)malloc(line_max + EUC_BUFFER)) == NULL){
			fprintf(stderr,"Error: _test_01_1  buf_malloc( %d )\n",line_max);
			return -1;
	}
	while( (bl = itextBufferGets(bhead)) != NULL ){

		memset(ebuf,0,line_max + EUC_BUFFER);

		if( itextConvKanjiCode(icon,ebuf,bl->p,bl->l) < 0 ){
			fprintf(stderr,"Error: _test_01_1 (%d)\n",bl->l);
			continue;
		}

		total_size += (len = strlen(ebuf));
		xtext_usage(XJP_MESSAGE[7],(double)total_size/file_size,50);



		if( _check_buffer(book,ebuf,len,&total_line) == 0){

			if( SMLL ){
				if( checkSmlStr(bl,line_max,icon) ) SMLL = 0;
			}

			continue;
		}

		ihead = NULL; itail = NULL;
		itext_add(ebuf,&ihead,&itail);

		ibuf_add(&(book->b_head),&(book->b_tail),ihead,itail,ebuf,total_line); 
		total_line++;
	}

	itextBufferFree(bhead);

	if(ebuf) free(ebuf);
	if(sbuf) free(sbuf);


	return total_line;
}
static ftype_t _open_file(ICONTENT_T *book,FILE ** fp,char **zip,int *fsize)
{
	struct stat sbuf; 
	ftype_t ftype;

	switch((ftype = itextCheckFileType(book->filename))){

		case F_TXT: 
		case F_HTM:

			if((*fp = fopen(book->filename,"r")) == NULL){
				fprintf(stderr,"Error: open_file()(txt)\n"); 
				return F_BIP;
			}
		break;

		case F_ZIP:

			itextUnZipFile(book->filename,zip,&(book->o_head));
			if(*zip == NULL){
				fprintf(stderr,"Error: unzip_file()\n"); 
				return F_BIP; 
			}
			if((*fp = fopen(*zip,"r")) == NULL){
			       fprintf(stderr,"Error: open_file()(zip)\n"); 
				   return F_BIP; 
			}
		break;

		default:
			       fprintf(stderr,"Error: open_file()(?)\n"); 
				   return F_BIP;
		break;
	}

	fstat(fileno(*fp),&sbuf); 
	*fsize = sbuf.st_size;

	return ftype;
}
int itextGetTextData(ICONTENT_T *book,int ruby_on,int buf_size)
{
#if READ_ON 
	struct timeval tv0,tv1;
#endif
	FILE *fp = NULL;
	char *zipfname = NULL;
	int total_line,file_size = 0;
	iconv_t icon;
	ftype_t ftype;

#if READ_ON
	gettimeofday(&tv0,NULL);
#endif
	
	if((ftype = _open_file(book,&fp,&zipfname,&file_size)) == F_BIP) 
		return -1;

	RUBYON = ruby_on;

	xtext_usage(NULL,0,0);
	icon = itextConvOpen(fp,NULL);


	if(ftype == F_TXT || ftype == F_ZIP){

		if( (total_line = _test_01_1(fp,icon,book,buf_size,file_size)) <= 0)
				fprintf(stderr,"TOTAL_LINE = %d\n",total_line);

	}else if(ftype == F_HTM){

		if( (total_line = _test_02(fp,icon,book,RUBYON,buf_size,file_size)) <= 0)
				fprintf(stderr,"TOTAL_LINE = %d\n",total_line);
	}else{
		exit(1);
	}

#if READ_ON
	gettimeofday(&tv1,NULL);
	if( tv0.tv_usec > tv1.tv_usec )
		printf("%ld : %ld\n",tv1.tv_sec - tv0.tv_sec,tv1.tv_usec);
	else
		printf("%ld : %ld\n",tv1.tv_sec - tv0.tv_sec,tv1.tv_usec - tv0.tv_usec);
#endif

	itextConvClose(icon); fclose(fp);
	xtext_usage(NULL,0,0);

	if(zipfname != NULL){ 
		unlink(zipfname); 
		free(zipfname);
	}

	return total_line;
}
