#include "itext.h"
#include "xtext.h"
#include "xjp.h"
#include <stdarg.h>
#include <time.h>

extern int opterr; 
extern int optind; 
extern char *optarg;
extern int getopt(int argc,char * const * argv,const char * pattern);
extern my_window_t *main_win;

/*
static void _usage()
{
	fprintf(stderr,"\n");
	fprintf(stderr,"    %s  Version : %s\n\n",XTEXT_NAME,XTEXT_VERSION);
	fprintf(stderr," E_MAIL : %s\n",XTEXT_EMAIL);
	fprintf(stderr,"HOMEPAGE: %s\n\n\n",XTEXT_HOMEPAGE);
	fprintf(stderr,"Usage:	xjp [option] (-f file_path)\n\n");
	fprintf(stderr,"[option]\n");
	fprintf(stderr,	
"   -h       Help Message (This Message)\n \
  -d <dir>   Book Directory\n \
  -f <file>  Book(.txt|.zip) Path\n \
  -a <num>   Window Width\n \
  -b <num>   Window Height\n \
  -c <str>   Main Window-Color (X11 Color_Name)\n \
  -e <str>   Main Font-Color (X11 Color_Name)\n \
  -g <str>   Ruby Font-Color (X11 Color_Name)\n \
  -i <str>   Message Font-Color (X11 Color_Name)\n \
  -j <str>   Message Window-Color (X11 Color_Name)\n \
  -k <str>   Main Font_Name (Xlfd format)\n \
  -l <str>   Sub Font_Name (Xlfd format)\n \
  -m <str>   1Byte Font_Name (xlfd format)\n \
  -n <str>   Ruby Font_Name (xlfd format)\n \
  -o         Use Xft (0?1)\n \
  -p <num>   Line Space (Pixel)\n \
  -q <num>   Row Space (Pixel)\n \
  -r         Display Book_Title (0?1)\n \
  -s	     Display Page_No (0?1) \n \
  -t	     Display Ruby_Char (0?1) \n \
  -u <path>  Rast-Data-Base Path \n \
					 ");
	fprintf(stderr,"\n");
	exit(1);
}	
*/
/*
char * xtext_get_option(int c,char **v,xtext_conf_t *xconf)
{
	int option;

	while(1){
		if((option = getopt(c,v,"a:b:c:d:e:f:g:i:j:k:l:m:n:p:q:u:o:r:s:t:h")) == -1) break;
		switch(option){
			case 'h': _usage(); break;
			case 'f':return optarg;break;
			case 'd':_xconf_malloc(xconf->book_dir,128,optarg);break;
			case 'a':xconf->main_window_width = atoi(optarg);break;
			case 'b':xconf->main_window_height = atoi(optarg);break;
			case 'c':_xconf_malloc(xconf->main_window_color,64,optarg);break;
			case 'e':_xconf_malloc(xconf->main_font_color,64,optarg);break;
			case 'g':_xconf_malloc(xconf->rubi_font_color,64,optarg);break;
			case 'i':_xconf_malloc(xconf->menu_font_color,64,optarg);break;
			case 'j':_xconf_malloc(xconf->menu_window_color,64,optarg);break;
			case 'k':_xconf_malloc(xconf->main_font_j,128,optarg);break;
			case 'l':_xconf_malloc(xconf->main_font_s,128,optarg);break;
			case 'm':_xconf_malloc(xconf->main_font_e,128,optarg);break;
			case 'n':_xconf_malloc(xconf->rubi_font,128,optarg);break;
			case 'o':xconf->anti = atoi(optarg);break;
			case 'p':xconf->line_space = atoi(optarg);break;
			case 'q':xconf->row_space = atoi(optarg);break;
			case 'r':xconf->title_on = atoi(optarg);break;
			case 's':xconf->page_on = atoi(optarg);break;
			case 't':xconf->ruby_on = atoi(optarg);break;
			case 'u':_xconf_malloc(xconf->rast_db,128,optarg);break;

			default: _usage(); break;
		}
	}
	return NULL;
}
*/
void xjp_xconf(xtext_conf_t *xconf)
{
	fprintf(stderr,"\nXCONF START\n");

	fprintf(stderr,"IMAGE:%s\n",xconf->main_window_img);
	fprintf(stderr,"WCOLOR:%s\n",xconf->main_window_color);
	fprintf(stderr,"FCOLOR:%s\n",xconf->main_font_color);
	fprintf(stderr,"SCOLOR:%s\n",xconf->main_shadow_color);
	fprintf(stderr,"FINDCO:%s\n",xconf->find_font_color);
	fprintf(stderr,"RUBICO:%s\n",xconf->rubi_font_color);
	fprintf(stderr,"MENUCO:%s\n",xconf->menu_window_color);
	fprintf(stderr,"MENFCO:%s\n",xconf->menu_font_color);
	fprintf(stderr,"SELWCO:%s\n",xconf->select_window_color);
	fprintf(stderr,"SELFCO:%s\n",xconf->select_font_color);
	fprintf(stderr,"SELBCO:%s\n",xconf->select_font_background_color);
	fprintf(stderr,"POINCO:%s\n",xconf->pointer_fg_color);

	fprintf(stderr,"FONTJ:%s\n",xconf->main_font_j);
	fprintf(stderr,"FONTS:%s\n",xconf->main_font_s);
	fprintf(stderr,"FONTE:%s\n",xconf->main_font_e);
	fprintf(stderr,"FONTR:%s\n",xconf->rubi_font);
	fprintf(stderr,"CHUKF:%s\n",xconf->chuki_font);
	fprintf(stderr,"ORGFO:%s\n",xconf->org_font);

	fprintf(stderr,"BOOKD:%s\n",xconf->book_dir);

	fprintf(stderr,"WIDTH:%d\n",xconf->main_window_width);
	fprintf(stderr,"HEIGH:%d\n",xconf->main_window_height);
	fprintf(stderr,"ANTIF:%d\n",xconf->anti);
	fprintf(stderr,"TITIL:%d\n",xconf->title_on);
	fprintf(stderr,"RUBY :%d\n",xconf->ruby_on);
	fprintf(stderr,"PAGE :%d\n",xconf->page_on);
	fprintf(stderr,"KINSC:%d\n",xconf->kinsc);
	fprintf(stderr,"CURSO:%d\n",xconf->cursor);
	fprintf(stderr,"CHUKI:%d\n",xconf->chuki);
	fprintf(stderr,"LINES:%d\n",xconf->line_space);
	fprintf(stderr,"ROW S:%d\n",xconf->row_space);
	fprintf(stderr,"RUBIS:%d\n",xconf->rubi_space);
	fprintf(stderr,"PAGEF:%d\n",xconf->page_feed0);
	fprintf(stderr,"PAGEF:%d\n",xconf->page_feed1);
	fprintf(stderr,"PAGER:%d\n",xconf->page_reverse);
	fprintf(stderr,"PAGES:%ld\n",xconf->page_speed);

	fprintf(stderr,"\nXCONF END\n");

}
void xjp_error(Display *disp,XErrorEvent *er)
{
		time_t etime;
		struct tm *tmval;

		FILE *fp;

		char *type0 = "XRequest";
		char *type = "XlibMessage";

		char num[32],buf0[BUFSIZ],buf1[BUFSIZ];
		char er_file_path[256],time_log[256];

		xtextSubWindow_Message(disp,main_win,XJP_MESSAGE[25]);

		etime = time(NULL);
		tmval = localtime(&etime);
		strftime(time_log,sizeof(time_log),"%Y/%m/%d %H:%M:%S",tmval);

		sprintf(er_file_path,"%s/%s/%s",XJP_HOME,CONF_DIR_NAME,ERROR_LOG_FILE);
		if( (fp = fopen(er_file_path,"a")) == NULL) 
				fp = stderr;

		fprintf(fp,"----- %s -----\n",time_log);

		sprintf(num,"%d",er->request_code);
		XGetErrorDatabaseText(disp,type0,num,"",buf0,BUFSIZ);
		fprintf(fp,"%s\n",buf0);

		XGetErrorText(disp,er->error_code,buf0,BUFSIZ);
		XGetErrorDatabaseText(disp,type,"XError","",buf1,BUFSIZ);
		fprintf(fp,"(%s : %s)\n",buf1,buf0);

		XGetErrorDatabaseText(disp,type,"MajorCode","%d",buf0,BUFSIZ);
		sprintf(buf0,buf0,er->request_code);
		fprintf(fp,"%s\n",buf0);

		XGetErrorDatabaseText(disp,type,"MinorCode","%d",buf0,BUFSIZ);
		fprintf(fp,buf0,er->minor_code);
		fprintf(fp,"\n");
		XGetErrorDatabaseText(disp,type,"ErrorSerial","%d",buf0,BUFSIZ);
		fprintf(fp,buf0,er->serial);
		fprintf(fp,"\n");


		if(er->error_code == BadValue){
			XGetErrorDatabaseText(disp,type,"Value","0x%x",buf1,BUFSIZ);
		}else if(er->error_code == BadAtom){
			XGetErrorDatabaseText(disp,type,"AtomID","0x%x",buf1,BUFSIZ);
		}else{
			XGetErrorDatabaseText(disp,type,"ResourceID","0x%x",buf1,BUFSIZ);
		}
		fprintf(fp,buf1,er->resourceid);
		fprintf(fp,"\n");
		fprintf(fp,"--------------------------------\n");
		fprintf(fp,"\n");

		if( fp != stderr ) fclose(fp);

		return;
}
int xtext_create_offsetFile(char *filename)
{
	FILE *fp;

	unsigned char it[3];
	long j;
	int i;

        char *title = "\
\
# Ĵե\n\
#\n\
# ʸɤϡEUCǤե¸EUCλ\n\
# ʲоʸ[-7  +7 ԥ] ϰϤĴǽǤ\n\
#\n\
# {\"оʸ\",\"1Х\",\"2Х\",\"xĴ\",\"yĴ\"}\n\
\
		       ";


       long t[] = {	0xa1,0xa7,0xa8,0xbc,0xbd,0xc1,0xc3,0xc4,0xc5,
	       		0xcc,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,
			0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdd,0xe0,
			0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xa2,0xa3,0xc6,
			0xc7,0xc8,0xc9,0xaa,0xab,0xac,0xad,0xa1,0xa3,
			0xa5,0xa7,0xa9,0xc3,0xe3,0xe5,0xe7,0xee,0xc3,0xa1,
			0xa5,0xa7,0xa9,0xc3,0xe3,0xee,0xe7,0xf5,0xf6,
			0xca,0xcb					};


	if( (fp = fopen(filename,"w")) == NULL) return -1;

	fprintf(fp,"%s",title);
        fprintf(fp,"\n\n");
        it[0] = 0xa1;
        for(j=0xd6;j<0xda;j++){
                it[1] = j;
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
       fprintf(fp,"\n\n");
       it[0] = 0xa1;
       for(i = 0; i < 66; i++){
		if(i >= 19 && i <= 22) continue;

		if( (i >= 0 && i <= 31) || (i == 64) || (i == 65) ){
			it[1] = t[i];
		        it[2] = '\0';
		        fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);

		}

	}
        fprintf(fp,"\n\n");
        it[0] = 0xa2;
        for(i = 39; i < 43; i++){
		it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa8;
        for(j = 0xa0; j <= 0xbc; j++){
                it[1] = j;
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa1;
        for(i = 33; i < 35; i++){
		it[1] = t[i];
	        it[2] = '\0';
	        fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
	}
        fprintf(fp,"\n\n");
	it[0] = 0xa1;
        for(i = 35; i < 39; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa4;
        for(i = 43; i < 53; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
        fprintf(fp,"\n\n");
        it[0] = 0xa5;
        for(i = 53; i < 64; i++){
                it[1] = t[i];
                it[2] = '\0';
                fprintf(fp,"{\"%s\",\"0x%x\",\"0x%x\",\"0\",\"0\"}\n",it,it[0],it[1]);
        }
	fprintf(fp,"\n\n");

	fclose(fp);

	return 0;
}

