#include "itext.h"
#include "xtext.h"
#include "xjp.h"

#if HAVE_LIBIMLIB

#include <X11/extensions/shape.h>
#include <Imlib.h>

int xtextImlibPasteImage(	ImlibData *id,
				ImlibImage *im,
				Window win,
				int xpos,
				int ypos	)
{
	int w,h;

	if( im == NULL ) return -1;

	w = im->rgb_width; h = im->rgb_height;

	Imlib_paste_image(id,im,win,xpos,ypos,w,h);


	return h;
}

ImlibImage * xtextImlibImage(	Display *disp,
				ImlibData *id,
				ImlibImage **im,
				char *filename	)
{

	/*
	int w,h;
	*/

	if((*im = Imlib_load_image(id,filename)) == NULL){
		fprintf(stderr,"Error: im null xtext_f18.c\n");
		return NULL;
	}

	/*
	if( im->rgb_width > width ){
		w = width;
		h = im->rgb_height * ( width / im->rgb_width );
	}else{
		w = im->rgb_width;
		h = im->rgb_height;
	}
	Imlib_render(id,im,w,h);
	*/

	return *im;
}

Pixmap xtextCreatePict(Display *disp,Window win,GC gc,char *iname,int *width,int *height)
{
	Pixmap pix;

	ImlibData *id;
	ImlibImage *im;

	if( (id = Imlib_init(disp)) == NULL){
		fprintf(stderr,"Error: Imlib_init\n");
	       	return 0;
	}

	if( id->x.depth > 24 )
		id->x.depth = 24;


	if( xtextImlibImage(disp,id,&im,iname) == NULL ) return 0;

	*width = im->rgb_width;
	*height = im->rgb_height;


	pix = XCreatePixmap(disp,win,im->rgb_width,im->rgb_height,DefaultDepth(disp,0));

	Imlib_paste_image(id,im,pix,0,0,im->rgb_width,im->rgb_height);

	Imlib_destroy_image(id,im);

	return pix;
}

#endif


