#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <iconv.h>
#include <pthread.h>

#include "xtext_1.h"

static void _func19_e0(etext_t *h)
{
	etext_t *e,*et;

	if( h == NULL ) return;

	for( e = h; e != NULL; e = et ){
	       et = e->n;	
	       free(e);
	}
	
	return;
}
static void _func19_e1(etext_t *head)
{
	etext_t *et,*ett;

	if( head == NULL ) return;

	for( et = head; et != NULL; et = ett ){
		ett = et->n;

		if( et->eh != NULL){
			etext_t *et1,*et1_1;

			for( et1 = et->eh; et1 != NULL; et1 = et1_1 ){
				et1_1 = et1->n;
				free(et1);
			}
		}

		if( et->s != NULL ) free(et->s);
		free(et);
	}
}
static void _func19_e2(etext_t **h,unsigned char *p,int len)
{
	static etext_t *n;
	etext_t *e;

	e = (etext_t *)malloc(sizeof(etext_t));
	e->s = p;
	e->l = len;
	e->eh = NULL;
	e->n = NULL;

	if( *h == NULL ){
		*h = e;
	}else{
		n->n = e;
	}
	n = e;
}
void func19_e3(etext_t **head,unsigned char *str,int len)
{
	static etext_t *n;
	etext_t *et;

	if( str == NULL ) return;

	if( (et = (etext_t *)malloc(sizeof(etext_t))) == NULL){
		fprintf(stderr,"Error: etext_malloc()\n");
		return;
	}
	if( (et->s = (unsigned char *)malloc(len + 2)) == NULL){
		fprintf(stderr,"Error: etext_str_malloc\n");
		if( et ) free(et);
		return;
	}
	memset(et->s,'\0',len + 2);
	memcpy(et->s,str,len);
	et->l = len;
	et->eh = NULL;
	et->n = NULL;

	if( *head == NULL ){
		*head = et;
	}else{
		n->n = et;
	}
	n = et;
}
static int _func19_1(iconv_t icon,char *str1,unsigned char *str0,int len)
{

	char utf8[len * 2];

	size_t elen,ulen;

	char *utf;
	char *euc;
	int slen;

	if( str0 == NULL ) return 0;

	elen = len;
	slen = elen * 2;
	ulen = slen;

	euc = (char *)str0;

	memset(utf8,0,ulen);
	utf = utf8;
	iconv(icon,&euc,&elen,&utf,&ulen);

	slen -= ulen;
	memcpy(str1,utf8,slen);
	*(str1 + slen) = '\0';

	return slen;
}
static int _func19_2(unsigned char *str,int len)
{
	unsigned char *p;
	int f,i;

	f = 0;
	for( p = str, i = 0; i < len; p++,i++ ){

		if( *p >= 0xa1 && *p <= 0xfe) 
			f++;
		else
			f = 0;
	}
	if(f % 2 ) return 1;

	return 0;

}
static int _func19_3(etext_t *eh,int row,int *w)
{
	etext_t *e;
	unsigned char *p;
	int l,len,t = 0;

	if( eh != NULL ){
		for( e = eh; e != NULL; e = e->n ){
			if( e->eh != NULL )
				_func19_e0(e->eh);
			e->eh = NULL;
		}
	}

	if( row == 0 ){

		for( e = eh; e != NULL; e = e->n ){
			e->eh = NULL;
			if( e->l > *w ) *w = e->l;
			t++;
		}

	}else{

		for( e = eh; e != NULL; e = e->n ){
			if( e->l <= row ){
		      		e->eh = NULL;
				t++;
				continue;
			}

			l = 0;
			len = e->l;
			p = (unsigned char *)e->s;
			while(1){

				if( (l + row) < len ){

					if( _func19_2(p,row) ){
						_func19_e2(&(e->eh),p,row - 1);
						l -= 1;
						t++;

					}else{
						_func19_e2(&(e->eh),p,row);
						t++;

					}
				}else{
					_func19_e2(&(e->eh),p,len - l);
					t++;
					break;
				}

				l += row;
				p = e->s + l;

			}
		}
	}
	return t;
}
Pixmap func19_4(struct DTEXT *dtx )
{
	etext_t *e,*e1;

	XFontSet fs = 0;
	XFontSetExtents *fe;
	char **miss,*def;
	int n_miss;

	XWindowAttributes wattr;
	Pixmap pix;
	Visual *vis;
	Colormap cmp;
	int w,h;

#if HAVE_LIBXFT

	XftDraw *dr = NULL;
	XftFont *fn = NULL;
	char *utf8 = NULL;
	int ulen = 0;

	iconv_t icon = 0;

#endif

	int fw,fh;
	int i,x,row,line;

	unsigned char tmp[BUFSIZ];

	if( dtx->mutex ) pthread_mutex_lock(dtx->mutex);

	if( dtx->an ){
#if HAVE_LIBXFT
		if( (fn = XftFontOpenXlfd(dtx->disp,0,dtx->fname)) == NULL ){
			fprintf(stderr,"Error: Thread FontOpen\n");
			fprintf(stderr,"	%s\n",dtx->fname);
			return 0;
		}
		fw = fn->max_advance_width / 2;
		fh = fn->height;
#else
		if( (fs = XCreateFontSet(dtx->disp,dtx->fname,&miss,&n_miss,&def)) == NULL){
			fprintf(stderr,"Error: Thread FontSetOpen\n");
			return 0;
		}
		fe = XExtentsOfFontSet(fs);
		fw = fe->max_logical_extent.width / 2;
		fh = fe->max_logical_extent.height;

#endif
	}else{
		if( (fs = XCreateFontSet(dtx->disp,dtx->fname,&miss,&n_miss,&def)) == NULL){
			fprintf(stderr,"Error: Thread FontSetOpen\n");
			return 0;
		}
		fe = XExtentsOfFontSet(fs);
		fw = fe->max_logical_extent.width / 2;
		fh = fe->max_logical_extent.height;
	}

	XGetWindowAttributes(dtx->disp,dtx->win,&wattr);
	vis = wattr.visual;
	cmp = wattr.colormap;

	if( dtx->width ){
		w = dtx->width;
		row = w / fw;
		line = _func19_3(dtx->et,row - 1,&w);

	}else{
		w = 0;
		row = 0;
		line = _func19_3(dtx->et,0,&w);

	       	w = (w  * fw) + fw;
		row = w;
	}

	h = (fh + dtx->ls) * (line + 1);
	dtx->pwidth = w;
	dtx->pheight = h;

	if( dtx->height && (dtx->pheight < dtx->height) ){
		dtx->height = dtx->pheight;
		XResizeWindow(dtx->disp,dtx->win,dtx->width,dtx->height);
	}

	pix = XCreatePixmap(dtx->disp,dtx->pwin,w,h,DefaultDepth(dtx->disp,0));
	XFillRectangle(dtx->disp,pix,dtx->bgc,0,0,w,h);

	if( dtx->an ){
#if HAVE_LIBXFT
		if( (dr = XftDrawCreate(dtx->disp,pix,vis,cmp)) == NULL){
			fprintf(stderr,"Error: XftDrawCreate f19\n");
		}
		icon = iconv_open("UTF-8","EUC-JP");
		utf8 = (char *)malloc(row * 4);
#endif
	}


	x = 5;
	i = 1;
	for( e = dtx->et; e != NULL; e = e->n ){

		if( e->eh != NULL ){

			for( e1 = e->eh; e1 != NULL; e1 = e1->n ){
				memset(tmp,0,BUFSIZ);
				memcpy(tmp,e1->s,e1->l);
				memcpy(tmp + e1->l,"",2);

				if( dtx->an ){
#if HAVE_LIBXFT
					memset(utf8,0,row * 4);
					ulen = _func19_1(icon,utf8,tmp,e1->l + 2);

					XftDrawStringUtf8(dr,&dtx->col,fn,x,(fh + dtx->ls) * i++,(FcChar8 *)utf8,ulen);
#else
					XmbDrawString(dtx->disp,pix,fs,dtx->fgc,x,(fh + dtx->ls) * i++,(char *)tmp,e1->l+2);

#endif
				}else{
					XmbDrawString(dtx->disp,pix,fs,dtx->fgc,x,(fh + dtx->ls) * i++,(char *)tmp,e1->l+2);
				}
			}

		}else{
			if( dtx->an ){
#if HAVE_LIBXFT
				memset(utf8,0,row * 4);
				ulen = _func19_1(icon,utf8,e->s,e->l);
				XftDrawStringUtf8(dr,&dtx->col,fn,x,(fh + dtx->ls) * i++,(FcChar8 *)utf8,ulen);
#else
				XmbDrawString(dtx->disp,pix,fs,dtx->fgc,x,(fh + dtx->ls) * i++,(char *)e->s,e->l);

#endif
			}else{
				XmbDrawString(dtx->disp,pix,fs,dtx->fgc,x,(fh + dtx->ls) * i++,(char *)e->s,e->l);

			}
		}
	}

	if( dtx->an ){
#if HAVE_LIBXFT
		if( utf8 ) free(utf8);
		iconv_close(icon);
		XftFontClose(dtx->disp,fn);
		XftDrawDestroy(dr);
#else
		XFreeFontSet(dtx->disp,fs);

#endif
	}else{
		XFreeFontSet(dtx->disp,fs);
	}

	if( dtx->mutex ) pthread_mutex_unlock(dtx->mutex);

	return pix;
}
int xtextDisplayText(struct DTEXT *dtx)
{
	Pixmap pix;
	int STEP,YPOS;

	Display *dp;
	Window win,ro;
	XSetWindowAttributes attr;
	GC gc;
	XGCValues gv;
	int w,h;

	int loop;

	dp = dtx->disp;
	ro = dtx->pwin;
	gc = dtx->bgc;
	w = dtx->width;
	h = dtx->height;

	XGetGCValues(dp,gc,GCForeground,&gv);

	win = XCreateSimpleWindow(dp,ro,0,0,w,h,0,0,gv.foreground);
	XSelectInput(dp,win,ExposureMask | StructureNotifyMask | KeyPressMask );
	attr.backing_store = Always;
	XChangeWindowAttributes(dp,win,CWBackingStore,&attr);
	XDefineCursor(dp,win,dtx->cr);
	XStoreName(dp,win,dtx->wname);

	dtx->win = win;

	pix = func19_4(dtx);

	XMapWindow(dp,win);

	STEP = 5;
	YPOS = 0;
	loop = 1;
	while( loop ){
		XEvent ev;
		KeySym keysym;

		XNextEvent(dp,&ev);
		switch(ev.type){
			case Expose:
				XCopyArea(dp,pix,win,gc,0,YPOS,dtx->width,dtx->height,0,0);
			break;
			case ConfigureNotify:

				if( 	dtx->width != ev.xconfigure.width 	|| 
					dtx->height != ev.xconfigure.height	){

					if( pix ) XFreePixmap(dp,pix);

					dtx->width = ev.xconfigure.width;
					dtx->height = ev.xconfigure.height;

					pix = func19_4(dtx);

					YPOS = 0;
					XCopyArea(dp,pix,win,gc,0,YPOS,dtx->width,dtx->height,0,0);
				}

			break;
			case KeyPress:
				keysym = XLookupKeysym(&ev.xkey,0);
				switch(keysym){
					case XK_Down:
					case XK_j:
						if( dtx->pheight <= dtx->height ) break;
						if( (YPOS += STEP) >= dtx->pheight - dtx->height )
							YPOS = dtx->pheight - dtx->height;
						XCopyArea(dp,pix,win,gc,0,YPOS,dtx->width,dtx->height,0,0);

					break;

					case XK_Up:
					case XK_k:
						if( (YPOS -= STEP) <= 0 ) YPOS = 0;
						XCopyArea(dp,pix,win,gc,0,YPOS,dtx->width,dtx->height,0,0);
					break;

					case XK_q:
						loop = 0;
					break;
				}
		}
	}
	if( pix ) XFreePixmap(dp,pix);
	if( win ) XDestroyWindow(dp,win);

	XFlush(dp);

	return 0;
}
void * xtextOrgThreadFunc(void *arg)
{
	char *title = "Original-Text";

	IBUF_T *ib;
	struct DTEXT dtx;

	myorg_t *mg;
	my_window_t *my;

	int i,emax,len;

	pthread_detach(pthread_self());

	mg = (myorg_t *)arg;
	my = mg->m;

	if( (dtx.disp = XOpenDisplay(NULL)) == NULL ){
		fprintf(stderr,"Error: Thread XOpenDisplay\n");
	       	return NULL;
	}
	dtx.fname = mg->f;
	dtx.wname = title;

	dtx.an = my->anti;
	dtx.pwin = my->root;
	dtx.cr = my->pointer1;
	dtx.fgc = my->gc;
	dtx.bgc = my->rfgc;
	dtx.col = my->fg_color;
	dtx.width = my->width;
	dtx.height = my->height / 2;

	dtx.ls = 5;
	dtx.win = 0;
	dtx.pwidth = 0;
	dtx.pheight = 0;
	dtx.mutex = 0;
	dtx.et = NULL;

	emax = 0;
	for( ib = mg->bh,i = 0; ib != NULL; ib = ib->next,i++ ){
		if( mg->e_no >= 0 && i > mg->e_no ) break;
		if( i >= mg->s_no ){

			len = strlen(ib->str);
			if( emax < len ) emax = len;
			func19_e3(&(dtx.et),(unsigned char *)ib->str,len);

		}

	}
	dtx.et_max = emax;

	xtextDisplayText(&dtx);

	_func19_e1(dtx.et);

	/*
	XCloseDisplay(dtx.disp);
	*/

	return NULL;
}
void * xtextChuThreadFunc(void *arg)
{
	char *title = "Message-Text";

	chum_t *ct;
	char tmp[256];
	struct DTEXT dtx;

	mychu_t *mc;
	my_window_t *my;

	int i,len,emax;

	pthread_detach(pthread_self());

	mc = (mychu_t *)arg;
	my = mc->m;

	if( (dtx.disp = XOpenDisplay(NULL)) == NULL ){
		fprintf(stderr,"Error: Thread XOpenDisplay\n");
	       	return NULL;
	}
	dtx.fname = mc->f;
	dtx.wname = title;

	dtx.an = my->anti;
	dtx.pwin = my->root;
	dtx.cr = my->pointer1;
	dtx.fgc = my->gc;
	dtx.bgc = my->rfgc;
	dtx.col = my->fg_color;
	dtx.width = my->width;
	dtx.height = my->height / 2;

	dtx.ls = 5;
	dtx.win = 0;
	dtx.pwidth = 0;
	dtx.pheight = 0;

	dtx.mutex = 0;
	dtx.et = NULL;

	emax = 0;
	for( ct = mc->ch,i = 0; ct != NULL; ct = ct->next,i++ ){
		sprintf(tmp,"(%d) %s",ct->n,ct->s);

		len = strlen(tmp);
		if( emax < len ) emax = len;
		func19_e3(&(dtx.et),(unsigned char *)tmp,len);

	}
	dtx.et_max = emax;

	xtextDisplayText(&dtx);

	_func19_e1(dtx.et);

	/*
	XCloseDisplay(dtx.disp);
	*/

	return NULL;
}


