#include "itext.h"
#include "xtext.h"
#include "xjp.h"

#include "xtext_1.h"

#include <pthread.h>

static void _func5_1(etext_t *eh,int f)
{
	etext_t *e,*ee;

	for( e = eh; e != NULL; e = ee ){
		ee = e->n;

		if( f )
			if( e->s ) free(e->s);

		if( e->eh != NULL )
			_func5_1(e->eh,0);

		free(e);
	}
}
static struct DTEXT * _func5_0(		Display *disp,
					Window root,
					Window win,
					mypic_t *mp		)
{
	struct DTEXT *dtx;
	char *s;
	int i,len;

	if( (dtx = (struct DTEXT *)malloc(sizeof(struct DTEXT))) == NULL) 
		return NULL;

	dtx->mutex = mp->mutex;

	dtx->disp = disp;
	dtx->pwin = root;
	dtx->win = win;
	dtx->fname = mp->f;
	dtx->an = mp->m->anti;
	dtx->fgc = mp->m->fgc;
	dtx->bgc = mp->m->rfgc;
	dtx->col = mp->m->fg_color;

	dtx->width = 0;
	dtx->height = 0;
	dtx->ls = 5;
	dtx->pwidth = 0;
	dtx->pheight = 0;
	dtx->et_max = 0;
	dtx->et = NULL;


	for( i = 0; i < 2; i++ ){
		if( i == 0 ) s = XJP_MESSAGE[26];
		if( i == 1 ) s = mp->path;

		if( (len = strlen(s)) > dtx->et_max ) dtx->et_max = len;

		func19_e3(&(dtx->et),(unsigned char *)s,len);
	}

	return dtx;
}
void * xtextPicThreadFunc(void *arg)
{
	char *p,title[64];
	mypic_t *mp;

	struct DTEXT *dtx = NULL;

	Display *disp;
	Window root,win;
	Pixmap pix;
	GC gc;
	XSetWindowAttributes attr;
	XEvent ev;
	KeySym keysym;

	Visual *vis;
	Colormap cmap;

	int x,y,w,h,iw,ih;
	int loop;


	pthread_detach(pthread_self());

	mp = (mypic_t *)arg;

	if( (p = strrchr(mp->path,'/')) == NULL)
		p = mp->path;

	sprintf(title,"(%d) %s",mp->no,p);

	disp = XOpenDisplay(NULL);
	root = DefaultRootWindow(disp);
	gc = XCreateGC(disp,root,0,0);
	vis = DefaultVisual(disp,0);
	cmap = DefaultColormap(disp,0);


	win = XCreateSimpleWindow(	disp,
					root,
					0,
					0,
					10,
					10,
					0,
					0,
					0	);

	XSelectInput(	disp,
			win,
			ExposureMask |
			StructureNotifyMask |
			KeyPressMask 
    					    );
	attr.backing_store = Always;
	XChangeWindowAttributes(disp,win,CWBackingStore,&attr);
	XDefineCursor(disp,win,mp->m->pointer1);
	XStoreName(disp,win,title);


#if HAVE_LIBIMLIB

	if( mp->mutex ) pthread_mutex_lock(mp->mutex);

	pix = xtextCreatePict(disp,win,gc,mp->path,&iw,&ih);

	if( mp->mutex ) pthread_mutex_unlock(mp->mutex);

	if( iw < 100 ){
		w = 100; x = (w - iw) / 2;
	}else{
		w = iw; x = 0;
	}
	if( ih < 100 ){
		h = 100; y = (h - ih) / 2;
	}else{
		h = ih; y = 0;
	}

#else
	pix = 0;

	if( (dtx = _func5_0(disp,root,win,mp)) != NULL){

		pix = func19_4(dtx);

		iw = dtx->pwidth;
		ih = dtx->pheight;

		if(dtx->et != NULL ) _func5_1(dtx->et,1);

		free(dtx);
	}
	x = 0; y = 0;
	w = iw; h = ih;

#endif
	if( pix == 0 ) goto _end;


	XResizeWindow(disp,win,w,h);

	XMapWindow(disp,win);
	XCopyArea(disp,pix,win,gc,0,0,iw,ih,x,y);

	loop = 1;
	while(loop){
		XNextEvent(disp,&ev);
		switch(ev.type){
			case Expose:
				XCopyArea(disp,pix,win,gc,0,0,iw,ih,x,y);
			break;
			case KeyPress:
				keysym = XLookupKeysym(&ev.xkey,0);
				switch(keysym){
					case XK_q:
						loop = 0;
					break;
				}
			break;
		}
	}

_end:
	if( gc ) XFreeGC(disp,gc);
	if( pix ) XFreePixmap(disp,pix);
	if( win ) XDestroyWindow(disp,win);
	XFlush(disp);

	if( mp ) free(mp);


	return NULL;
}
